# OERSI WordPress Plugin

A WordPress version of the main OERSI application, providing simplified functionality including search capabilities and Elasticsearch integration.

## For WordPress Users

### Installation
1. Download the OERSI plugin ZIP file:
   - Visit the [GitLab project page](https://gitlab.com/TIBHannover/oer/wordpress-oersi-plugin)
   - Click on "Releases" in the left sidebar
   - Download the latest release ZIP file
2. Navigate to your WordPress admin panel
3. Go to Plugins > Add New > Upload Plugin
4. Choose the downloaded ZIP file and click "Install Now"
5. After installation, click "Activate"

### Setup
1. Configure required settings in the OERSI plugin menu
2. To activate search functionality on any page, add the shortcode: `[oersi_search]`

**Note**: Please review the documentation tab in each plugin section for specific configuration requirements, especially for ElasticSearch and Translation settings.

## For Developers

### Technology Stack
- PHP: Core plugin functionality
- React JS: Search frontend using Reactive Search
- ElasticSearch: Search backend

### Local Development Setup
1. Clone the repository into your WordPress plugins directory:
```bash
cd <wordpress_path>/wp-content/plugins/
git clone https://gitlab.com/TIBHannover/oer/wordpress-oersi-plugin oersi
cd oersi
```

2. Configure environment variables in `.env`:
```
OERSI_API_URL=http://<localhost>:<port>/oer/wp-json/oersi/v1
OERSI_ASSET_URL=http://<localhost>:<port>/oer/wp-content/plugins/oersi/assets/
```

3. Install dependencies:
```bash
composer update
npm install
```

4. Build the project:
```bash
npm run build:all
# Or individually:
npm run admin:build
npm run frontend:build
```

5. Start development servers:
```bash
# For admin development
cd packages/admin
npm start

# For frontend development
cd packages/frontend
npm run frontend:start
```

### Folder structure

```
oersi
├── .bin                   # contain phpDocumentor.phar: used for generating docs for PHP part.
├── .husky                 # contain git hook script that run before every commit, and check the php and javascript code convention.
├── .vscode                # folder that contains extension and settings for visual studio code.
├── docs                   # documentation generated by phpDocumentor.phar (Php Only).
├── assets                 # contains the build, including reactscript images css, and other js, needed for wordpress. (Final build)
├── inc                    # include the core of plugins (Php code)
    └── Api                # abstract classes for generating Wordpress pages,API and CallBacks
    └── Base               # contain all base classes, like Activate,Deactivate,Enqueue(JS/CSS), etc
    └── Pages              # contain all the implementations for pages.
    └── Updater            # Configuration for auto updater.
    └── Init.php           # Php file, that initialize all the classes
└── languages              # locale generated for wordpress
└── packages               # Contain the npm workspaces
    └── admin              # contain CSS JS, Images needed for admin part
    └── frontend           # React frontend part
└── Rest-Client            # Rest client Endpoint for API
└── templates             # frontend part for wordpress admin site
└── .editorconfig         # configuration file convention used to define and maintain consistent code styles
└── .env                  # environment variable
└── .eslintrc.json       # configuration file for eslint
└── .gitignore           # git ignore file
└── .gitlab-ci.yml       # configuration fie for gitlab CI/CD
└── .htaccess            # web server configuration files
└── .lintstagedrc        # configuration files used to run linters before commit happen
└── .nvmrc               # node version
└── .prettierignore      # ignore file for prettier
└── .prettierrc.json     # configuration file for prettier
└── composer.json        # configuration json file for getComposer
└── composer.lock        # file that contains exact version of download php packages
└── index.php           # empty file
└── oersi.php           # entry point of wordpress plugin
└── package.json        # configuration file for npm projects
└── package-lock.json   # file that contains exact version of download npm packages
└── phpcs.xml           # configuration file for PHP CodeSniffer, a php code standards detection
└── phpdoc.xml          # a config file for phpDocumentor
└── LICENSE             # License
└── CONTRIBUTING.md     # a md file for contributors, if they want to contribute
└── README.md          # a readm me file
```

### Available Scripts

#### PHP
- `composer run update`: Install PHP dependencies
- `composer run generate-docs`: Generate PHP documentation
- `composer run generate-locale-wp`: Generate/update translation files
- `composer run php-check`: Check PHP code convention
- `composer run php-fix`: Fix PHP code convention issues

#### JavaScript
- `npm run admin:build`: Build admin interface
- `npm run admin:start`: Watch and build admin changes
- `npm run admin:eslint`: Check admin code style
- `npm run frontend:build`: Build frontend
- `npm run frontend:start`: Watch and build frontend changes
- `npm run frontend:eslint`: Check frontend code style
- `npm run build:zip`: Create deployable plugin ZIP

For detailed documentation and contribution guidelines, see CONTRIBUTING.md.